/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* Application default file search path */
#define APPDEF_PATH "/opt/motifapp/%T/%L/%N"

static char buf[BUFSIZ];

static void SetSearchPath()
{
    char *current;

    /* (2) Get current environment value (remember user specified value) */
    current = getenv("XFILESEARCHPATH");

    if (current == NULL) /* (3) Use default path if user does not set */
        sprintf(buf, "%s=%s", "XFILESEARCHPATH", APPDEF_PATH);
    else /* (4) Concat the user specified and default path if user specified */
        sprintf(buf, "%s=%s:%s", "XFILESEARCHPATH", current, APPDEF_PATH);

    putenv(buf); /* (5) Set the environment variable for this program */
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, panel, control, label, text, button;
    Arg     al[20];
    int     ac;

    SetSearchPath(); /* (1) Set search path at the start of this program */

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Simple", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    ac = 0;
    label = XmCreateLabel(control, "label", al, ac);
    XtManageChild(label);

    ac = 0;
    text = XmCreateTextField(control, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    button = XmCreatePushButton(panel, "button", al, ac);
    XtManageChild(button);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
