/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, rowcol, toggle, text, button;
    Arg    al[20];
    int    ac;

    static char *value;
    XmString cstring;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Setvalues", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* Create widgets */

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    toggle = XmCreateToggleButton(rowcol, "toggle", al, ac);
    XtManageChild(toggle);

    ac = 0;
    text = XmCreateTextField(rowcol, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    button = XmCreatePushButton(rowcol, "button", al, ac);
    XtManageChild(button);


    /* Set resources after creating widgets */

    ac = 0;
    XtSetArg(al[ac], XmNmaxWidth, 400); ac++; /* Maximum allowable width */
    XtSetArg(al[ac], XmNmaxHeight, 200); ac++; /* Maximum allowable height */
    XtSetValues(toplevel, al, ac);

    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth, 20); ac++; /* margin width */
    XtSetArg(al[ac], XmNmarginHeight, 10); ac++; /* margin height */
    XtSetValues(rowcol, al, ac);

    ac = 0;
    XtSetArg(al[ac], XmNset, True); ac++; /* Set the toggle ON */
    XtSetValues(toggle, al, ac);

    /* Allocate the space and copy the text */
    value = XtMalloc(1024);
    strcpy(value, "Allocated Text");

    ac = 0;
    XtSetArg(al[ac], XmNvalue, value); ac++; /* Set the text */
    XtSetValues(text, al, ac);

    /* Create a label for push button (Compound String) */
    cstring = XmStringCreateLocalized("Push this Button");

    ac = 0;
    XtSetArg(al[ac], XmNlabelString, cstring); ac++; /* Set label string */
    XtSetValues(button, al, ac);

    XtFree(value); /* This value is no longer necessary */
    XmStringFree(cstring); /* This compound string is no longer necessary */

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
